<script lang="ts">
import Vue, { PropType } from 'vue';
import { CtfEntry, CtfTheSourceGatedAsset } from '~/models';

export default Vue.extend({
  name: 'TheSourceResources',
  props: {
    resources: {
      type: Array as PropType<Array<CtfEntry<CtfTheSourceGatedAsset>>>,
      required: true,
    },
    surfaceBg: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
});
</script>

<template>
  <div :class="['ts-resources', { 'ts-resources--surface-bg': surfaceBg }]">
    <SlpTypography class="slp-mb-16" tag="h4" variant="all-caps">{{
      $t('articles.resources')
    }}</SlpTypography>
    <div
      v-for="resource in resources"
      :key="resource.fields.title"
      class="ts-resources__resource"
    >
      <div class="slp-flex slp-mb-4">
        <SlpIcon name="lock" variant="product" class="slp-mr-4" />
        <SlpTypography tag="h5" variant="all-caps">{{
          $t(`articles.guide`)
        }}</SlpTypography>
      </div>
      <SlpButton
        :href="resource.fields?.gatedAssetLink"
        variant="tertiary"
        target="_blank"
      >
        <SlpTypography tag="span" variant="body2-bold">{{
          resource.fields.title
        }}</SlpTypography>
      </SlpButton>
      <SlpTypography
        v-if="resource.fields.description"
        tag="span"
        variant="body2-bold"
        >{{ resource.fields.description }}</SlpTypography
      >
      <SlpButton
        v-if="resource.fields?.gatedAssetLink"
        :href="resource.fields?.gatedAssetLink"
        variant="tertiary"
        target="_blank"
      >
        <SlpTypography tag="span" variant="body3-bold">{{
          $t('articles.access')
        }}</SlpTypography>
      </SlpButton>
    </div>
  </div>
</template>

<style scoped lang="scss">
.ts-resources {
  margin-top: $spacing-24;
  padding: $spacing-24;
  background-color: white;
  border-radius: $spacing-8;
  position: sticky;
  top: $spacing-24;
  width: 100%;

  &--surface-bg {
    background-color: $color-surface-100 !important;
  }

  &__resource {
    display: flex;
    flex-direction: column;
    border-top: 1px solid $color-surface-300;
    margin-top: $spacing-16;
    padding-top: $spacing-16;
    text-align: start;
    justify-content: flex-start;

    &:first-of-type {
      margin-top: 0;
    }

    &:last-of-type {
      margin-bottom: 0;
    }

    .slp-btn {
      padding-top: $spacing-8;
      padding-bottom: 0;
      text-align: start;

      &:hover {
        color: $color-text-link-100;
        text-decoration-color: $color-text-link-100;
      }
    }
  }
}
</style>
